"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var t = __importStar(require("io-ts"));
var immutable_1 = require("immutable");
var Either_1 = require("fp-ts/lib/Either");
/**
 * A codec for the List type from immutable.
 * This codec decodes a javascript array into an immutable list, and it encodes the immutable list to a javascript array
 * @param codec The codec for the list items.
 * @since 0.1.0
 */
function list(codec) {
    return new t.Type("List<" + codec.name + ">", function (u) { return immutable_1.List.isList(u) && u.every(function (uItem) { return codec.is(uItem); }); }, function (u, context) {
        var decodedArray = t.array(codec).validate(u, context);
        if (Either_1.isLeft(decodedArray)) {
            return t.failure(u, context, "Could not decode the input to an array");
        }
        return t.success(immutable_1.List(decodedArray.right));
    }, function (l) { return l.map(codec.encode).toArray(); });
}
exports.list = list;
//# sourceMappingURL=list.js.map