"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var t = __importStar(require("io-ts"));
var immutable_1 = require("immutable");
var Either_1 = require("fp-ts/lib/Either");
/**
 * A codec for the Set type from immutable.
 * This codec decodes a javascript array into an immutable set, and it encodes the immutable set to a javascript array
 * @param codec The codec for the set items.
 * @since 0.2.0
 */
function set(codec) {
    return new t.Type("Set<" + codec.name + ">", function (u) { return immutable_1.Set.isSet(u) && u.every(function (uItem) { return codec.is(uItem); }); }, function (u, context) {
        var decodedArray = t.array(codec).validate(u, context);
        if (Either_1.isLeft(decodedArray)) {
            return t.failure(u, context, "Could not decode input to an array");
        }
        return t.success(immutable_1.Set(decodedArray.right));
    }, function (s) { return s.map(codec.encode).toArray(); });
}
exports.set = set;
//# sourceMappingURL=set.js.map